"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var S = _interopRequireWildcard(require("./Typography.styles.js"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const elements = {
  headings: {
    h1: 'h1',
    h1Light: 'h1',
    h2: 'h2',
    h3: 'h3',
    h4: 'h4'
  },
  body: 'p',
  label: 'label',
  input: 'label',
  button: 'label'
};
const allowedProps = {
  blank: {
    target: '_blank'
  },
  download: {
    download: true
  }
};
const Typography = /*#__PURE__*/(0, _react.forwardRef)(({
  className,
  children,
  type = 'body',
  variant = 'primary',
  text,
  ...rest
}, ref) => {
  const value = children || text;
  let linksMatched = [];
  let formatForReplace = '';
  let currentLink = 0;
  let links = [];
  if (value && typeof value === 'string') {
    const regex = new RegExp(/(\[[\w +.!#%^&+@:/()*$_?=`|/\\-]+\](\([\w0-9+.!#%^&+@:/*$_?=`|/\\-]+\))(\((blank|download)\))?)+/g);
    linksMatched = value?.match(regex) || [];
    formatForReplace = value?.replace(regex, '${replace}');
    links = linksMatched?.map(matched => {
      const text = matched.match(/\[[\w +.!#%^&+@:/()*$_?=`|/\\-]+\]/g)?.[0]?.slice(1, -1);
      const link = matched.substring(matched.indexOf('(') + 1, matched.indexOf(')'));
      const props = matched.substring(matched.lastIndexOf('(') + 1, matched.lastIndexOf(')'));
      return /*#__PURE__*/_react.default.createElement("a", {
        href: link,
        rel: "noopener",
        ...allowedProps[props]
      }, text);
    });
  }
  const renderTypography = localChildren => /*#__PURE__*/_react.default.createElement(S.TyporaphyDefault, {
    as: elements[type][variant] || elements[type],
    className: className,
    type: type,
    variant: variant,
    ref: ref,
    ...rest
  }, localChildren);
  return links && links?.length ? renderTypography(formatForReplace?.split(/(\${replace})/).map((word, index) => {
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: index
    }, word === '${replace}' ? links && links[currentLink++] : word);
  })) : renderTypography(value);
});
var _default = Typography;
exports.default = _default;